/* $Id: mosca_image.tcc,v 1.2 2013/01/25 20:35:35 cgarcia Exp $
 *
 * This file is part of the MOSCA library
 * Copyright (C) 2013 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: cgarcia $
 * $Date: 2013/01/25 20:35:35 $
 * $Revision: 1.2 $
 * $Name: fors-4_9_20 $
 */

#ifndef MOSCA_IMAGE_TCC
#define MOSCA_IMAGE_TCC

#include <stdexcept>
#include "mosca_image.h"
#include "type_traits.h"

cpl_size mosca::image::size_x() const
{
    return cpl_image_get_size_x(m_image);
}

cpl_size mosca::image::size_y() const
{
    return cpl_image_get_size_y(m_image);
}

mosca::axis mosca::image::dispersion_axis() const
{
    return m_dispersion_axis;
}

mosca::axis mosca::image::spatial_axis() const
{
    return m_spatial_axis;
}

template<typename T>
T* mosca::image::get_data()
{
    if(mosca::type_trait<T>::cpl_eq_type != cpl_image_get_type(m_image))
        throw std::invalid_argument("type requested does not match image data type");
    T* data;
    data = static_cast<T*>(cpl_image_get_data(m_image));
    return data;
}
    
#endif
